
From: Dipankar Sarma <dipankar@in.ibm.com>

Fix memory leak - free on copyin failure.



 25-akpm/drivers/char/rio/rioboot.c |    1 +
 1 files changed, 1 insertion(+)

diff -puN drivers/char/rio/rioboot.c~ds-12-rio-memleak-fix drivers/char/rio/rioboot.c
--- 25/drivers/char/rio/rioboot.c~ds-12-rio-memleak-fix	Tue Jun 10 14:55:28 2003
+++ 25-akpm/drivers/char/rio/rioboot.c	Tue Jun 10 14:55:28 2003
@@ -326,6 +326,7 @@ register struct DownLoad *rbp;
 
 			if ( copyin((int)rbp->DataP,DownCode,rbp->Count)==COPYFAIL ) {
 				rio_dprintk (RIO_DEBUG_BOOT, "Bad copyin of host data\n");
+				sysfree( DownCode, rbp->Count );
 				p->RIOError.Error = COPYIN_FAILED;
 				func_exit ();
 				return -EFAULT;

_
